//+------------------------------------------------------------------+
//|                                                   GG-RSI-CCI.mq4 |
//|                                         Copyright  2009, GGekko |
//|                                         http://www.fx-ggekko.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, GGekko"
#property link      "http://www.fx-ggekko.com"

//---- indicator settings
#property indicator_separate_window
#property indicator_buffers  4
#property indicator_color1   YellowGreen
#property indicator_color2   Gold
#property indicator_color3   Gold
#property indicator_color4   OrangeRed
#property indicator_width1   2
#property indicator_width2   2
#property indicator_width3   2
#property indicator_width4   2
#property indicator_minimum  0
#property indicator_maximum  1.5 

//

extern string __Copyright__   = "www.fx-ggekko.com";
extern int    Avg_Period1     = 8;
extern int    Avg_Period2     = 14;
extern int    Ind_Period      = 20;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsNotify    = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//---- indicator buffers
double     BufferUp[];
double     BufferFt1[];
double     BufferFt2[];
double     BufferDn[];
double     ind1[];
double     ind2[];
double     ind3[];
double     ind4[];
double     ind5[];
double     ind6[];
double     trend1[];
double     trend2[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(12);
   SetIndexBuffer(0,BufferUp);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,BufferFt1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,BufferFt2); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,BufferDn);  SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,ind1);
   SetIndexBuffer(5,ind2);
   SetIndexBuffer(6,ind3);
   SetIndexBuffer(7,ind4);
   SetIndexBuffer(8,ind5);
   SetIndexBuffer(9,ind6);
   SetIndexBuffer(10,trend1);
   SetIndexBuffer(11,trend2);
   IndicatorShortName("GG-RSI-CCI ("+Avg_Period1+","+Avg_Period2+","+Ind_Period+") * www.fx-ggekko.com * ");
   return(0);
  }

int start()
{

   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) ind1[i] = iRSI(NULL,0,Ind_Period,PRICE_CLOSE,i);
   for(i=limit; i>=0; i--) ind2[i] = iCCI(NULL,0,Ind_Period,PRICE_CLOSE,i);
   for(i=limit; i>=0; i--) 
   {
      ind3[i] = iMAOnArray(ind1,0,Avg_Period1,0,MODE_SMMA,i);
      ind4[i] = iMAOnArray(ind1,0,Avg_Period2,0,MODE_SMMA,i);
      ind5[i] = iMAOnArray(ind2,0,Avg_Period1,0,MODE_SMMA,i);
      ind6[i] = iMAOnArray(ind2,0,Avg_Period2,0,MODE_SMMA,i);
      
      //
      //
      //
      //
      //
      
      BufferUp[i]  = EMPTY_VALUE; 
      BufferFt1[i] = EMPTY_VALUE;
      BufferFt2[i] = EMPTY_VALUE;
      BufferDn[i]  = EMPTY_VALUE;
      trend1[i] = trend1[i+1]; 
      trend2[i] = trend2[i+1];
      if(ind3[i]>ind4[i]) trend1[i] = 1; 
      if(ind3[i]<ind4[i]) trend1[i] =-1; 
      if(ind5[i]>ind6[i]) trend2[i] = 1;
      if(ind5[i]<ind6[i]) trend2[i] =-1;
      if (trend1[i]== 1 && trend2[i]== 1) BufferUp[i]  = 1;
      if (trend1[i]==-1 && trend2[i]==-1) BufferDn[i]  = 1;
      if (trend1[i]==-1 && trend2[i]== 1) BufferFt1[i] = 1; 
      if (trend1[i]== 1 && trend2[i]==-1) BufferFt2[i] = 1;
      
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      
      if (trend1[whichBar] != trend1[whichBar+1] || trend2[whichBar] != trend2[whichBar+1])
      {
         if (trend1[whichBar] == 1 && trend2[whichBar] == 1) doAlert(whichBar,"strong up");
         if (trend1[whichBar] ==-1 && trend2[whichBar] ==-1) doAlert(whichBar,"strong down");
         if (trend1[whichBar] == 1 && trend2[whichBar] ==-1) doAlert(whichBar,"flat");
         if (trend1[whichBar] ==-1 && trend2[whichBar] == 1) doAlert(whichBar,"flat");
      }                
   }
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //
          
          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," gg-rsi-cci ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," gg-rsi-cci "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
} 
 
   
